%bcond_with manpage

Summary:  Graphical Boot Animation and Logger
Name:     plymouth
Version:  22.02.122
Release:  8%{?dist}
License:  GPLv2+
URL:      http://www.freedesktop.org/wiki/Software/Plymouth
Source0:  https://gitlab.freedesktop.org/plymouth/plymouth/-/archive/%{version}/plymouth-%{version}.tar.gz
Source2:  charge.plymouth
Patch0001:0001-drm-Retry-setting-scanout-buffer-on-failure.patch
Patch0002:0002-Add-support-for-CSI-sequences.patch
Patch0003:0003-ply-utils-Reintroduce-ply_string_has_prefix-helper.patch
Patch0004:0004-ply-device-manager-Treat-SimpleDRM-drm-devices-as-fb.patch

BuildRequires: make, gcc, libtool, intltool, kernel-headers, gettext-devel
BuildRequires: pkgconfig(gtk+-3.0), pango-devel >= 1.21.0, cairo-devel, pkgconfig(libdrm), pkgconfig(libudev), libpng-devel
%if %{with manpage}
BuildRequires: libxslt, docbook-style-xsl
%endif

Requires: %{name}-core-libs = %{version}-%{release}
Requires: %{name}-scripts = %{version}-%{release}
Suggests: logrotate

%description
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

%package core-libs
Summary: Plymouth core libraries

%description core-libs
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the core libraries used by Plymouth.

%package devel
Summary: Developing files of Plymouth
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the developing files needed to develop
3rd party splash plugins for Plymouth.

%package scripts
Summary: Plymouth related scripts
Requires: findutils, coreutils, gzip, cpio, dracut
Requires: %{name} = %{version}-%{release}

%description scripts
This package contains scripts that help integrate Plymouth with
the system.

%package system-theme
Summary: Plymouth default theme
Requires: plymouth(system-theme) = %{version}-%{release}

%description system-theme
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This is a meta-package providing a default theme to Plymouth.

%package graphics-libs
Summary: Plymouth graphics libraries
Requires: %{name}-core-libs = %{version}-%{release}
Requires: system-logos

%description graphics-libs
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the libraries used by graphical Plymouth splashes.

%package plugin-label
Summary: Plymouth label plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-graphics-libs = %{version}-%{release}

%description plugin-label
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the label control plugin for Plymouth.
It provides the ability to render text on graphical boot splashes.

%package plugin-script
Summary: Plymouth "script" plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-graphics-libs = %{version}-%{release}

%description plugin-script
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "script" boot splash plugin for Plymouth. It features
an extensible boot splash language that allows writing new plugins as scripts, 
simplifying the process of designing custom boot splash themes.


%package plugin-fade-throbber
Summary: Plymouth "Fade-Throbber" plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-graphics-libs = %{version}-%{release}

%description plugin-fade-throbber
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "Fade-In" boot splash plugin for Plymouth. It 
features a centered image that fades in and out while other images pulsate 
around during system boot up.

%package plugin-space-flares
Summary: Plymouth "space-flares" plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-graphics-libs = %{version}-%{release}
Requires: plymouth-plugin-label = %{version}-%{release}

%description plugin-space-flares
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "space-flares" boot splash plugin for
Plymouth. It features a corner image with animated flares.

%package plugin-two-step
Summary: Plymouth "two-step" plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-graphics-libs = %{version}-%{release}
Requires: plymouth-plugin-label = %{version}-%{release}
Obsoletes: %{name}-plugin-throbgress < %{version}-%{release}

%description plugin-two-step
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "two-step" boot splash plugin for
Plymouth. It features a two phased boot process that starts with
a progressing animation synced to boot time and finishes with a
short, fast one-shot animation.

%package theme-charge
Summary: Plymouth "Charge" plugin
Requires: %{name}-plugin-two-step = %{version}-%{release}
Requires: system-logos
Requires(post): plymouth-scripts

%description theme-charge
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "charge" boot splash theme for
Plymouth. It features the shadowy hull of an OS logo charge up and and 
finally burst into full form.

%package theme-fade-in
Summary: Plymouth "Fade-In" theme
Requires: %{name}-plugin-fade-throbber = %{version}-%{release}
Requires(post): plymouth-scripts

%description theme-fade-in
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "Fade-In" boot splash theme for
Plymouth. It features a centered logo that fades in and out
while stars twinkle around the logo during system boot up.

%package theme-script
Summary: Plymouth "Script" plugin
Requires: %{name}-plugin-script = %{version}-%{release}
Requires(post): plymouth-scripts

%description theme-script
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "script" boot splash theme for
Plymouth. It it is a simple example theme the uses the "script"
plugin.

%package theme-solar
Summary: Plymouth "Solar" theme
Requires: %{name}-plugin-space-flares = %{version}-%{release}
Requires(post): plymouth-scripts

%description theme-solar
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "Solar" boot splash theme for
Plymouth. It features a blue flamed sun with animated solar flares.

%package theme-spinfinity
Summary: Plymouth "Spinfinity" theme
Requires: %{name}-plugin-two-step = %{version}-%{release}
Requires(post): plymouth-scripts

%description theme-spinfinity
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "Spinfinity" boot splash theme for
Plymouth. It features a centered logo and animated spinner that
spins in the shape of an infinity sign.

%package theme-spinner
Summary: Plymouth "Spinner" theme
Requires: %{name}-plugin-two-step = %{version}-%{release}
Requires: font(cantarell) font(cantarelllight)
Requires(post): plymouth-scripts
Provides: plymouth(system-theme) = %{version}-%{release}

%description theme-spinner
Plymouth is an application that runs very early in the boot process (even 
before the root filesystem is mounted!) that provides a graphical boot 
animation while the boot process happens in the background.

It is designed to work on systems with DRM modesetting drivers. The idea is 
that early on in the boot process the native mode for the computer is set, 
plymouth uses that mode, and that mode stays throughout the entire boot 
process up to and after X starts. Ideally, the goal is to get rid of all 
flicker during startup.

For systems that don't have DRM mode settings drivers, plymouth falls back 
to text mode (it can also use a legacy /dev/fb interface).

This package contains the "spinner" boot splash theme for
Plymouth. It features a small spinner on a dark background.



%prep
%autosetup -p1



%build
autoreconf --install --symlink -Wno-portability
sed -i -e 's/spinner/bgrt/g' src/plymouthd.defaults
%configure --enable-tracing                                      \
           --with-logo=%{_datadir}/pixmaps/system-logo-white.png \
           --with-background-start-color-stop=0x0073B3           \
           --with-background-end-color-stop=0x00457E             \
           --with-background-color=0x3391cd                      \
%if %{with manpage}
           --enable-documentation                                \
%else
           --disable-documentation                               \
%endif
           --with-runtimedir=/run                                \
           --disable-gdm-transition                              \
           --enable-systemd-integration                          \
           --without-system-root-install                         \
           --without-rhgb-compat-link                            \
;

%make_build



%install
%make_install
%find_lang %{name}
find %{buildroot} -name '*.la' -delete

mkdir -p %{buildroot}%{_localstatedir}/lib/plymouth

mkdir -p %{buildroot}%{_datadir}/plymouth/themes/charge
cp %{SOURCE2} %{buildroot}%{_datadir}/plymouth/themes/charge
cp %{buildroot}%{_datadir}/plymouth/themes/glow/{box,bullet,entry,lock}.png %{buildroot}%{_datadir}/plymouth/themes/charge

rm -rf %{buildroot}%{_datadir}/plymouth/themes/glow



%post core-libs -p /sbin/ldconfig

%postun core-libs -p /sbin/ldconfig

%post graphics-libs -p /sbin/ldconfig

%postun graphics-libs -p /sbin/ldconfig

%postun theme-charge
export PLYMOUTH_PLUGIN_PATH=%{_libdir}/plymouth/
if [ $1 -eq 0 ]; then
    if [ "$(%{_sbindir}/plymouth-set-default-theme)" == "charge" ]; then
        %{_sbindir}/plymouth-set-default-theme --reset
    fi
fi

%postun theme-fade-in
export PLYMOUTH_PLUGIN_PATH=%{_libdir}/plymouth/
if [ $1 -eq 0 ]; then
    if [ "$(%{_sbindir}/plymouth-set-default-theme)" == "fade-in" ]; then
        %{_sbindir}/plymouth-set-default-theme --reset
    fi
fi

%postun theme-solar
export PLYMOUTH_PLUGIN_PATH=%{_libdir}/plymouth/
if [ $1 -eq 0 ]; then
    if [ "$(%{_sbindir}/plymouth-set-default-theme)" == "solar" ]; then
        %{_sbindir}/plymouth-set-default-theme --reset
    fi
fi

%postun theme-spinfinity
export PLYMOUTH_PLUGIN_PATH=%{_libdir}/plymouth/
if [ $1 -eq 0 ]; then
    if [ "$(%{_sbindir}/plymouth-set-default-theme)" == "spinfinity" ]; then
        %{_sbindir}/plymouth-set-default-theme --reset
    fi
fi

%post theme-spinner
export PLYMOUTH_PLUGIN_PATH=%{_libdir}/plymouth/
if [ $1 -eq 2 ]; then
    if [ "$(%{_sbindir}/plymouth-set-default-theme)" == "charge" ]; then
        %{_sbindir}/plymouth-set-default-theme bgrt
    fi
fi

%postun theme-spinner
export PLYMOUTH_PLUGIN_PATH=%{_libdir}/plymouth/
if [ $1 -eq 0 ]; then
    if [ "$(%{_sbindir}/plymouth-set-default-theme)" == "bgrt" -o \
         "$(%{_sbindir}/plymouth-set-default-theme)" == "spinner" ]; then
        %{_sbindir}/plymouth-set-default-theme --reset
    fi
fi


%files -f %{name}.lang
%license COPYING
%doc AUTHORS README
%dir %{_libexecdir}/plymouth
%dir %{_localstatedir}/lib/plymouth
%dir %{_datadir}/plymouth
%dir %{_datadir}/plymouth/themes
%dir %{_datadir}/plymouth/themes/details
%dir %{_datadir}/plymouth/themes/text
%dir %{_libdir}/plymouth/renderers
%dir %{_sysconfdir}/plymouth
%config(noreplace) %{_sysconfdir}/plymouth/plymouthd.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/bootlog
%{_sbindir}/plymouthd
%{_libexecdir}/plymouth/plymouthd-fd-escrow
%{_bindir}/plymouth
%{_libdir}/plymouth/details.so
%{_libdir}/plymouth/text.so
%{_libdir}/plymouth/tribar.so
%{_datadir}/plymouth/themes/details/details.plymouth
%{_datadir}/plymouth/themes/text/text.plymouth
%{_datadir}/plymouth/themes/tribar/tribar.plymouth
%{_datadir}/plymouth/plymouthd.defaults
%{_localstatedir}/spool/plymouth
%if %{with manpage}
%{_mandir}/man?/*
%endif
%ghost %{_localstatedir}/lib/plymouth/boot-duration
%{_prefix}/lib/systemd/system/

%files core-libs
%{_libdir}/libply.so.*
%{_libdir}/libply-splash-core.so.*
%{_libdir}/libply-boot-client.so.*
%dir %{_libdir}/plymouth

%files devel
%{_libdir}/libply.so
%{_libdir}/libply-splash-core.so
%{_libdir}/libply-boot-client.so
%{_libdir}/libply-splash-graphics.so
%{_libdir}/pkgconfig/ply-splash-core.pc
%{_libdir}/pkgconfig/ply-splash-graphics.pc
%{_libdir}/pkgconfig/ply-boot-client.pc
%{_libdir}/plymouth/renderers/x11*
%{_includedir}/plymouth-1

%files scripts
%{_sbindir}/plymouth-set-default-theme
%{_libexecdir}/plymouth/plymouth-update-initrd
%{_libexecdir}/plymouth/plymouth-generate-initrd
%{_libexecdir}/plymouth/plymouth-populate-initrd

%files graphics-libs
%{_libdir}/libply-splash-graphics.so.*
%{_libdir}/plymouth/renderers/drm*
%{_libdir}/plymouth/renderers/frame-buffer*

%files plugin-label
%{_libdir}/plymouth/label.so

%files plugin-script
%{_libdir}/plymouth/script.so

%files plugin-fade-throbber
%{_libdir}/plymouth/fade-throbber.so

%files plugin-space-flares
%{_libdir}/plymouth/space-flares.so

%files plugin-two-step
%{_libdir}/plymouth/two-step.so

%files theme-charge
%{_datadir}/plymouth/themes/charge

%files theme-fade-in
%{_datadir}/plymouth/themes/fade-in

%files theme-script
%{_datadir}/plymouth/themes/script

%files theme-solar
%{_datadir}/plymouth/themes/solar

%files theme-spinfinity
%{_datadir}/plymouth/themes/spinfinity

%files theme-spinner
%{_datadir}/plymouth/themes/bgrt
%{_datadir}/plymouth/themes/spinner

%files system-theme

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.02.122-8
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.02.122-7
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.02.122-6
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.02.122-5
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.02.122-4
- Rebuilt for OpenCloudOS Stream 23

* Wed Dec 7 2022 Zhao Zhen <jeremiazhao@tencent.com> - 22.02.122-3
- modified some descriptions

* Wed Dec 7 2022 Zhao Zhen <jeremiazhao@tencent.com> - 22.02.122-2
- recoverd building plymouth plugins

* Wed Sep 21 2022 Zhao Zhen <jeremiazhao@tencent.com> - 22.02.122-1
- Initial building
